<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>celtool/stdpcimp.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">celtool/stdpcimp.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.</span>
<a name="l00018"></a>00018 <span class="comment">*/</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __CEL_CELTOOL_STDPC__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_CELTOOL_STDPC__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/comp_8h.html">iutil/comp.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/iutil_2objreg_8h.html">iutil/objreg.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/reporter_8h.html">ivaria/reporter.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csobject_8h.html">csutil/csobject.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf__implementation_8h.html">csutil/scf_implementation.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/refarr_8h.html">csutil/refarr.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/weakref_8h.html">csutil/weakref.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;celtool/celtoolextern.h&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;physicallayer/propchg.h&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;physicallayer/propclas.h&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;physicallayer/propfact.h&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;physicallayer/pl.h&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;physicallayer/messaging.h&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00042"></a>00042 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObjectRegistry.html">iObjectRegistry</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="keyword">struct </span>Property
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>            id;
<a name="l00048"></a>00048   celDataType           datatype;
<a name="l00049"></a>00049   <span class="keywordtype">bool</span>                  readonly;
<a name="l00050"></a>00050   <span class="keyword">const</span> <span class="keywordtype">char</span>*           desc;
<a name="l00051"></a>00051   Property () : id (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga441e9321397d7398ee7f4da14ba477c8">csInvalidStringID</a>) { }
<a name="l00052"></a>00052 };
<a name="l00053"></a>00053 
<a name="l00059"></a><a class="code" href="structPropertyHolder.html">00059</a> <span class="keyword">struct </span><a class="code" href="structPropertyHolder.html" title="Keep a static instance of this structure in your property class so that your property class can imple...">PropertyHolder</a>
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   Property* properties;
<a name="l00062"></a>00062   <span class="keywordtype">size_t</span> propertycount;
<a name="l00063"></a>00063   <span class="comment">// Set to true if we have done an action.</span>
<a name="l00064"></a>00064   <span class="keywordtype">bool</span> actions_done;
<a name="l00065"></a>00065   <span class="comment">// The mask that we will use to listen for messages.</span>
<a name="l00066"></a>00066   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> mask;
<a name="l00067"></a>00067 
<a name="l00072"></a><a class="code" href="structPropertyHolder.html#a2e0b5410e17801a49eb94e87cb5dfc1c">00072</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">csHash&lt;int, csStringID&gt;</a> <a class="code" href="structPropertyHolder.html#a2e0b5410e17801a49eb94e87cb5dfc1c" title="This is a special hash that maps ID&#39;s to constants so that we can use a switch to see which ID it is...">constants</a>;
<a name="l00073"></a>00073 
<a name="l00078"></a><a class="code" href="structPropertyHolder.html#aee6da5c9ee68c5e92c26e0b55339f3d5">00078</a>   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsHash.html">csHash&lt;int, csStringID&gt;</a> <a class="code" href="structPropertyHolder.html#aee6da5c9ee68c5e92c26e0b55339f3d5" title="This hash is like &#39;constants&#39; except that it is used for new-style action id&#39;s (like &#39;cel...">new_constants</a>;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <a class="code" href="structPropertyHolder.html" title="Keep a static instance of this structure in your property class so that your property class can imple...">PropertyHolder</a> () : properties (0), propertycount (0), actions_done (false)
<a name="l00081"></a>00081   { }
<a name="l00082"></a>00082   ~<a class="code" href="structPropertyHolder.html" title="Keep a static instance of this structure in your property class so that your property class can imple...">PropertyHolder</a> () { <span class="keyword">delete</span>[] properties; }
<a name="l00083"></a>00083   <span class="keywordtype">void</span> SetCount (<span class="keywordtype">int</span> cnt)
<a name="l00084"></a>00084   {
<a name="l00085"></a>00085     <span class="keywordflow">if</span> (properties) <span class="keywordflow">return</span>;
<a name="l00086"></a>00086     propertycount = cnt;
<a name="l00087"></a>00087     properties = <span class="keyword">new</span> Property[cnt];
<a name="l00088"></a>00088   }
<a name="l00089"></a>00089 };
<a name="l00090"></a>00090 
<a name="l00096"></a><a class="code" href="classcelPcCommon.html">00096</a> <span class="keyword">class </span>CEL_CELTOOL_EXPORT <a class="code" href="classcelPcCommon.html" title="This is a common implementation for a property class from which all other property classes can inheri...">celPcCommon</a>
<a name="l00097"></a>00097   : <span class="keyword">public</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classscfImplementation4.html">scfImplementation4</a>&lt;celPcCommon, iCelPropertyClass, iCelTimerListener,
<a name="l00098"></a>00098     iMessageSender,iMessageReceiver&gt;
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100 <span class="keyword">private</span>:
<a name="l00101"></a>00101   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRefArray.html">csRefArray&lt;iCelPropertyChangeCallback&gt;</a> callbacks;
<a name="l00102"></a>00102   <span class="comment">// This flag is true if we currently don&#39;t know the state of</span>
<a name="l00103"></a>00103   <span class="comment">// the sibling property classes (property classes in the same</span>
<a name="l00104"></a>00104   <span class="comment">// entity). It is set to true by PropertyClassesHaveChanged()</span>
<a name="l00105"></a>00105   <span class="comment">// and cleared by HavePropertyClassesChanged().</span>
<a name="l00106"></a>00106   <span class="keywordtype">bool</span> propclasses_dirty;
<a name="l00107"></a>00107   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> tag;
<a name="l00108"></a>00108   <span class="comment">// the name of the property class stored in the iObject</span>
<a name="l00109"></a>00109   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsObject.html">csObject</a> csobj;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="keyword">static</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> id_tag;
<a name="l00112"></a>00112   <span class="keyword">static</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> id_name;
<a name="l00113"></a>00113   <span class="keyword">static</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> id_value;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="keyword">protected</span>:
<a name="l00116"></a>00116   <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity;
<a name="l00117"></a>00117   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObjectRegistry.html">iObjectRegistry</a>* object_reg;
<a name="l00118"></a>00118   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsWeakRef.html">csWeakRef&lt;iCelPlLayer&gt;</a> pl;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">protected</span>:
<a name="l00121"></a>00121   <span class="keywordtype">void</span> FirePropertyChangeCallback (<span class="keywordtype">int</span> propertyId);
<a name="l00122"></a>00122 
<a name="l00126"></a>00126   <span class="keywordtype">void</span> SetActionMask (<span class="keyword">const</span> <span class="keywordtype">char</span>* mask);
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="classcelPcCommon.html#ab5945c8b98c349d72be91e98ff590887">00131</a>   <span class="keywordtype">void</span> AddAction (<span class="keywordtype">int</span> idx, <span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>)
<a name="l00132"></a>00132   {
<a name="l00133"></a>00133     propholder-&gt;actions_done = <span class="keyword">true</span>;
<a name="l00134"></a>00134     propholder-&gt;constants.Put (pl-&gt;FetchStringID (<span class="keywordtype">id</span>), idx);
<a name="l00135"></a>00135     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> newid = propholder-&gt;mask;
<a name="l00136"></a>00136     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cssysdef_8h.html#ac380bd47888ecfe73e7b7a40b6f827a1">CS_ASSERT</a> (newid.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsStringBase.html#a4d4820df67848ac1040af1896c2dd280">Length</a> () &gt; 0);
<a name="l00137"></a>00137     newid += id;
<a name="l00138"></a>00138     propholder-&gt;new_constants.Put (pl-&gt;FetchStringID (newid), idx);
<a name="l00139"></a>00139   }
<a name="l00140"></a>00140 
<a name="l00152"></a><a class="code" href="classcelPcCommon.html#ae49d96b36984d838bf1ac6413e93802e">00152</a>   <span class="keywordtype">void</span> AddProperty (<span class="keywordtype">size_t</span> idx, <span class="keyword">const</span> <span class="keywordtype">char</span>* <span class="keywordtype">id</span>,
<a name="l00153"></a>00153         celDataType type, <span class="keywordtype">bool</span> readonly, <span class="keyword">const</span> <span class="keywordtype">char</span>* desc,
<a name="l00154"></a>00154         <span class="keywordtype">void</span>* prop)
<a name="l00155"></a>00155   {
<a name="l00156"></a>00156     <span class="comment">// return if an invalid index was specified</span>
<a name="l00157"></a>00157     <span class="keywordflow">if</span> (idx &gt;= propholder-&gt;propertycount)
<a name="l00158"></a>00158     {
<a name="l00159"></a>00159       <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iReporter&gt;</a> rep = csQueryRegistry&lt;iReporter&gt;(object_reg);
<a name="l00160"></a>00160       <span class="keywordflow">if</span> (rep)
<a name="l00161"></a>00161         rep-&gt;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga64c3e8fa49ffa59a8c718aa3ed0e41d8">ReportError</a>(<span class="stringliteral">&quot;crystalspace.cel.physicallayer&quot;</span>,
<a name="l00162"></a>00162             <span class="stringliteral">&quot;celPcCommon::AddProperty out of bounds %zu &gt;= %zu!&quot;</span>,
<a name="l00163"></a>00163             idx, propholder-&gt;propertycount);
<a name="l00164"></a>00164       <span class="keywordflow">else</span>
<a name="l00165"></a>00165         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gad4b0fa911161355ff8284407897d2537">csPrintf</a>(<span class="stringliteral">&quot;Error: celPcCommon::AddProperty out of bounds %zu &gt;= %zu!&quot;</span>,
<a name="l00166"></a>00166             idx, propholder-&gt;propertycount);
<a name="l00167"></a>00167       <span class="keywordflow">return</span>;
<a name="l00168"></a>00168     }
<a name="l00169"></a>00169     <span class="keywordflow">if</span> (propdata == 0)
<a name="l00170"></a>00170     {
<a name="l00171"></a>00171       propdata = <span class="keyword">new</span> <span class="keywordtype">void</span>* [propholder-&gt;propertycount];
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173     Property&amp; pr = propholder-&gt;properties[idx];
<a name="l00174"></a>00174     <span class="keywordflow">if</span> (pr.id == <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga441e9321397d7398ee7f4da14ba477c8">csInvalidStringID</a>)
<a name="l00175"></a>00175     {
<a name="l00176"></a>00176       pr.id = pl-&gt;FetchStringID (<span class="keywordtype">id</span>);
<a name="l00177"></a>00177       pr.datatype = type;
<a name="l00178"></a>00178       pr.readonly = readonly;
<a name="l00179"></a>00179       pr.desc = desc;
<a name="l00180"></a>00180       propholder-&gt;constants.Put (pr.id, (<span class="keywordtype">int</span>)idx);
<a name="l00181"></a>00181     }
<a name="l00182"></a>00182     propdata[idx] = prop;
<a name="l00183"></a>00183   }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="keywordtype">void</span>** propdata;
<a name="l00186"></a>00186   <a class="code" href="structPropertyHolder.html" title="Keep a static instance of this structure in your property class so that your property class can imple...">PropertyHolder</a>* propholder;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="keyword">private</span>:
<a name="l00189"></a>00189   <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00190"></a>00190   <span class="keywordtype">bool</span> SetPropertyTemplated (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyId, T l,
<a name="l00191"></a>00191     celDataType type);
<a name="l00192"></a>00192   <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00193"></a>00193   T GetPropertyTemplated (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyId, celDataType type);
<a name="l00194"></a>00194   <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00195"></a>00195   <span class="keywordtype">bool</span> GetPropertyTemplated (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> propertyId, celDataType type, T&amp; v);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="keyword">public</span>:
<a name="l00198"></a>00198   <a class="code" href="classcelPcCommon.html" title="This is a common implementation for a property class from which all other property classes can inheri...">celPcCommon</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObjectRegistry.html">iObjectRegistry</a>* object_reg);
<a name="l00199"></a>00199   <span class="keyword">virtual</span> ~<a class="code" href="classcelPcCommon.html" title="This is a common implementation for a property class from which all other property classes can inheri...">celPcCommon</a> ();
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordtype">bool</span> HavePropertyClassesChanged ()
<a name="l00202"></a>00202   {
<a name="l00203"></a>00203     <span class="keywordflow">if</span> (!propclasses_dirty) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00204"></a>00204     propclasses_dirty = <span class="keyword">false</span>;
<a name="l00205"></a>00205     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00206"></a>00206   }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetTag (<span class="keyword">const</span> <span class="keywordtype">char</span>* tagname);
<a name="l00209"></a>00209   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* GetTag ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> tag; }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__meshplugins.html#gabce9506f1104e1dfd1b05ceb3a8e1fe7">GetName</a> () <span class="keyword">const</span>;
<a name="l00212"></a>00212   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetName (<span class="keyword">const</span> <span class="keywordtype">char</span>* pcname);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiObject.html">iObject</a> *QueryObject ();
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* GetEntity () { <span class="keywordflow">return</span> entity; }
<a name="l00217"></a>00217   <span class="keyword">virtual</span> <span class="keywordtype">void</span> SetEntity (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity);
<a name="l00218"></a>00218   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> AddPropertyChangeCallback (<a class="code" href="structiCelPropertyChangeCallback.html" title="This is a callback that is called whenever a property changes for some property class.">iCelPropertyChangeCallback</a>* cb);
<a name="l00219"></a>00219   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> RemovePropertyChangeCallback (
<a name="l00220"></a>00220         <a class="code" href="structiCelPropertyChangeCallback.html" title="This is a callback that is called whenever a property changes for some property class.">iCelPropertyChangeCallback</a>* cb);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keywordtype">long</span>) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00223"></a>00223   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keywordtype">float</span>) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00224"></a>00224   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keywordtype">bool</span>) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>*) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00226"></a>00226   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00227"></a>00227   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00228"></a>00228   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00229"></a>00229   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pclass)
<a name="l00230"></a>00230   { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00231"></a>00231   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00232"></a>00232   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetPropertyIndexed (<span class="keywordtype">int</span>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* ibase) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <span class="keywordtype">long</span>);
<a name="l00235"></a>00235   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <span class="keywordtype">float</span>);
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <span class="keywordtype">bool</span>);
<a name="l00237"></a>00237   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <span class="keyword">const</span> <span class="keywordtype">char</span>*);
<a name="l00238"></a>00238   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp;);
<a name="l00239"></a>00239   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp;);
<a name="l00240"></a>00240   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp;);
<a name="l00241"></a>00241   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pclass);
<a name="l00242"></a>00242   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity);
<a name="l00243"></a>00243   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> SetProperty (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* ibase);
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keywordtype">long</span>&amp; l) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00246"></a>00246   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keywordtype">float</span>&amp; f) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00247"></a>00247   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keywordtype">bool</span>&amp; b) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00248"></a>00248   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>*&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00249"></a>00249   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00250"></a>00250   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00251"></a>00251   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00252"></a>00252   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>*&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00253"></a>00253   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>*&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00254"></a>00254   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyIndexed (<span class="keywordtype">int</span>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>*&amp;) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="keyword">virtual</span> <span class="keywordtype">long</span> GetPropertyLongByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00257"></a>00257   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetPropertyFloatByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00258"></a>00258   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyBoolByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00259"></a>00259   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* GetPropertyStringByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00260"></a>00260   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyVectorByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp;);
<a name="l00261"></a>00261   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyVectorByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp;);
<a name="l00262"></a>00262   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> GetPropertyColorByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp;);
<a name="l00263"></a>00263   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* GetPropertyPClassByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00264"></a>00264   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* GetPropertyEntityByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00265"></a>00265   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* GetPropertyIBaseByID (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> PerformAction (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>*, <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; ret);
<a name="l00268"></a>00268   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> PerformActionIndexed (<span class="keywordtype">int</span>, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>*, <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; ret)
<a name="l00269"></a>00269   { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00270"></a>00270   <span class="keyword">virtual</span> <span class="keyword">const</span> <span class="keywordtype">char</span>* GetPropertyOrActionDescription (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00271"></a>00271   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> GetPropertyAndActionCount ();
<a name="l00272"></a>00272   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> GetPropertyOrActionID (<span class="keywordtype">size_t</span>);
<a name="l00273"></a>00273   <span class="keyword">virtual</span> <span class="keywordtype">void</span> PropertyClassesHaveChanged ()
<a name="l00274"></a>00274   {
<a name="l00275"></a>00275     propclasses_dirty = <span class="keyword">true</span>;
<a name="l00276"></a>00276   }
<a name="l00277"></a>00277   <span class="keyword">virtual</span> celDataType GetPropertyOrActionType (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00278"></a>00278   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> IsPropertyReadOnly (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a>);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> SaveFirstPass () { <span class="keywordflow">return</span> 0; }
<a name="l00281"></a>00281   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> LoadFirstPass (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>*) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> Save () { <span class="keywordflow">return</span> 0; }
<a name="l00284"></a>00284   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> Load (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> GetPersistentData (
<a name="l00287"></a>00287         celPersistenceType persistence_type)
<a name="l00288"></a>00288     { <span class="keywordflow">return</span> 0; }
<a name="l00289"></a>00289   <span class="keyword">virtual</span> celPersistenceResult SetPersistentData (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga28e82998c4c2d1197a1d412bba7da793">csTicks</a> data_time, 
<a name="l00290"></a>00290         <a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* data, celPersistenceType persistence_type)
<a name="l00291"></a>00291     { <span class="keywordflow">return</span> CEL_PERSIST_RESULT_OK; };
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="comment">// --- For iCelTimerListener -----------------------------------------</span>
<a name="l00294"></a>00294   <span class="keyword">virtual</span> <span class="keywordtype">void</span> TickEveryFrame () { }
<a name="l00295"></a>00295   <span class="keyword">virtual</span> <span class="keywordtype">void</span> TickOnce () { }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   <span class="comment">// --- For iMessageSender --------------------------------------------</span>
<a name="l00298"></a>00298   <span class="keyword">virtual</span> <span class="keywordtype">void</span> MessageDispatcherRemoved (<a class="code" href="structiMessageDispatcher.html" title="This is a message dispatcher.">iMessageDispatcher</a>* dispatcher) { }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="comment">// --- For iMessageReceiver ------------------------------------------</span>
<a name="l00301"></a>00301   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> ReceiveMessage (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structCS_1_1StringID.html">csStringID</a> msg_id, <a class="code" href="structiMessageSender.html" title="This interface represents the sender of a message.">iMessageSender</a>* sender,
<a name="l00302"></a>00302       <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>&amp; ret, <a class="code" href="structiCelParameterBlock.html" title="This interface is a parameter block that can be used to pass parameters through SendMessage() in a be...">iCelParameterBlock</a>* params);
<a name="l00303"></a>00303 };
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 <span class="preprocessor">#endif // __CEL_CELTOOL_STDPC__</span>
<a name="l00306"></a>00306 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
